import { NetOption } from "pi_sys/net/http";
import { PISYS } from 'pi_sys/index';

declare var require;
/**
 * url解析
 * @param url 
 * @returns 
 */
export function parseUrlParams(url: string): any {
    const params = {};
    const queryString = url.split('?')[1];
    if (queryString) {
        const paramList = queryString.split('&');
        paramList.forEach(param => {
            const [key, value] = param.split('=');
            params[key] = decodeURIComponent(value);
        });
    }
    return params;
}


export const getModule = (moduleName: string): Promise<any> => {
    return new Promise(resolve => {
        require(moduleName, (module) => {
            resolve(module);
        });
    })
}


/**
 * http GET 请求(带重试机制),兼容旧版
 * @param url 
 * @param headers 
 * @param reqData 
 * @param respType 
 * @param netOption 
 * @param totalSize 
 */
export const httpGet = (url: string, headers: any, reqData: any, respType: string, netOption?: NetOption, totalSize: number = 100 * 1024) => {
    if (typeof PISYS.HTTP.httpGet === "function") {
        if (typeof netOption !== "object") {
            netOption = undefined;
        }
        return PISYS.HTTP.httpGet(url, headers, reqData, respType, netOption, totalSize);
    } else {
        return PISYS.HTTP.get(url, headers, reqData, respType, 10 * 1000);
    }
}