
export type InterfaceType = 'user_register' | 'user_login' | 'user_offline' | 'user_pay' 
    | 'user_device' | 'device_use' | 'bi_page_trace' | 'gi_data_change';

export interface user_register_data {
    /**
     * 1970年到现在的毫秒数
     */
    create_time: string;
    /**
     * 设备ID(登录前设备ID必须已存在)
     */
    device_id: string;
    /**
     * 应用名
     */
    app_id: string;
    /**
     * (用户ID)应用内唯一
     */
    user_id: string;
    /**
     * (用户名)允许空值
     */
    user_name: string;
    /**
     * 渠道名
     */
    channel_id: string;
    /**
     * 区服ID
     */
    server: string;
}
export interface user_login_data {
    /**
     * 1970年到现在的毫秒数
     */
    login_time: string;
    /**
     * 设备ID(登录前设备ID必须已存在)
     */
    device_id: string;
    /**
     * 应用名
     */
    app_id: string;
    /**
     * (用户ID)应用内唯一
     */
    user_id: string;
    /**
     * 应用版本
     */
    version: string;
    /**
     * 运营商(移动、电信、联通)
     */
    operator: string;
    /**
     * 网络(2G/3G/4G/5G/WIFI)
     */
    network: string;
    /**
     * 设备ip
     */
    device_ip: string;
}
export interface user_offline_data {
    /**
     * 1970年到现在的毫秒数
     */
    offline_time: string;
    /**
     * 应用名
     */
    app_id: string;
    /**
     * (用户ID)应用内唯一
     */
    user_id: string;
}
export interface user_pay_data {
    /**
     * 1970年到现在的毫秒数
     */
    order_time: string;
    /**
     * 应用名
     */
    app_id: string;
    /**
     * (用户ID)应用内唯一
     */
    user_id: string;
    /**
     * 订单号
     */
    order_id: string;
    /**
     * 充值渠道
     */
    pay_channel: string;
    /**
     * 货币类型
     */
    fee_type: string;
    /**
     * 充值金额
     */
    money: string;
    /**
     * 商品编号
     */
    goods_id: string;
    /**
     * 商品名
     */
    goods_name: string;
}
export interface user_device_data {
    /**
     * 1970年到现在的毫秒数
     */
    register_time: string;
    /**
     * 	设备ID
     */
    device_id: string;
    /**
     * 设备型号
     */
    device_model: string;
    /**
     * 系统版本
     */
    device_os: string;
    /**
     * 手机内存
     */
    device_total_memory: number;
    /**
     * 应用名
     */
    app_id: string;
}
export interface device_use_data {
    /**
     * 1970年到现在的毫秒数
     */
    time: string;
    /**
     * 设备ID
     */
    device_id: string;
}
export interface page_trace_data {
    /**
     * 1970年到现在的毫秒数
     */
    time: string;
    /**
     * 设备ID
     */
    device_id: string;
    /**
     * 应用ID
     */
    app_id: string;
    /**
     * [
     *      { page: 's', stay_time: 0 }
     * ]
     */
    data: string;
}
export interface gi_data_change_data {
    /**
     * 1970年到现在的毫秒数
     */
    create_time: string;
    /**
     * 应用名
     */
    app_id: string;
    /**
     * [ 
     *      user_id, [k,v,k2,v2...], 
     *      user_id2, [k,v,k2,v2...],
     *      ...
     * ]
     */
    data: string;
}