
import { PISYS } from "pi_sys/index";
import { DateMgr } from "pi_business_tool/date_mgr";
import { LocalStore, LocalStoreType } from 'pi_data/local_store';
import { getLogger } from "pi_tools/logger";
declare var module;
let { logI } = getLogger(module.name, "upload_mini");

export const sdkUpRegister = () => {
    sdkUpBase("active_register")
}
export const sdkUpActivePay = () => {
    sdkUpBase("active_pay")
}
export const sdkUpAd = () => {
    sdkUpBase("lt_roi")
}

export const sdkUpBase = (eventType: string, rid = 0) => {
    if (!window['tt']) return;

    let clickId = getClickid(eventType);
    if (!clickId) return console.error('no clickId');

    let url = 'https://analytics.oceanengine.com/api/v2/conversion';
    let reqData = {
        event_type: eventType,
        context: {
            ad: {
                callback: clickId
            }
        },
        timeStamp: DateMgr.now()
    }
    logI(`ad_tt ${eventType}`,  JSON.stringify(reqData));
    console.warn(url, reqData)
    PISYS.HTTP.post(url, null, JSON.stringify(reqData), 'application/json', undefined, 10000).then(res => {
        console.log(url, res)
    });
}

const getClickid = async(eventType: string) => {
    let launchOptions = window['tt'].getLaunchOptionsSync();
    let ad_params = launchOptions.query;
    if (!ad_params.clickid && launchOptions.ad_params) ad_params = launchOptions.ad_params;


    let clickId = ad_params.clickid;
    if (!clickId) {
        clickId = await LocalStore.read('dy_clickId', LocalStoreType.User)
    } else {
        logI("ad match", eventType, ad_params.adid, ad_params.creativeid);
        logI("sdkUpBase", eventType, ad_params.clickid);
        LocalStore.write("dy_clickId", clickId, LocalStoreType.User)
    }

    return clickId
}
