
import { PISYS } from "pi_sys/index";
import { IUploadUser, UploadType } from "../../interface/upload"
import { UploadPayParam } from "../../interface/pay"
import { registerAd, loginAd, payAd } from "./ksad";
import { payBaidu, registerBaidu } from "./baidu";
import { registerAdGdt, loginAdGdt, payAdGdt } from "./txgdt";
import { loginAdiosJL, payAdiosJL, registerAdiosJL } from "./ios_cdqxz";
import { firstOpen_wxMini, register_wxMini, pay_wxMini } from "./wx_minigame";
import { sdkUpActivePay, sdkUpRegister } from "./dy";
import { getWxQuery, miniGameAct, miniGameOpenid } from "./report_adevent";
declare var wx;
declare var tt;
/**
 * 买量广告数据上报-微信和抖音小程序，bilibili买量上报
 */
const system_info = PISYS.Env.get("system_info");
export class adGameUpload {

    //广点通小游戏回传需要的字段
    gdt_vid: string = ""; //广告traceid
    weixinadinfo: any = null;
    //巨量游戏
    req_id: string = undefined;
    clue_token: string = undefined;
    //taptap小游戏
    tap_track_id: string = undefined;  //用于追踪广告效果的参数
    tap_project_id: string = undefined; //在 tap 的游戏 id
    //快手小游戏
    ks_callback: string = undefined; //快手归因参数
    //bilibili小游戏
    bili_track_id: string = undefined;  //用于追踪广告效果的参数

    init: boolean = false
    isReport() {
        if (system_info.app == "wx_minigame" || system_info.app == "tt_minigame") {
            return true
        }
        return false
    }

    get getOpenId(): string {
        let key = system_info.app == "wx_minigame" ? "_$pi_wx_openid" : "_$pi_dy_openid"
        let openid = PISYS.Env.get(key);
        if (!openid) throw "get openId error"
        return openid
    }

    /** 小游戏激活（不是本地SDK的小游戏需要拿到openid后再发往后端激活），拿到openId后每次都要调用 */
    async firstActivation(param: any) {
        //如果是小游戏渠道，实现在这里获取小游戏的携带参数
        if (PISYS.PlatformUtil.isMinigame) {
            await getWxQuery();
            //小游戏拿到openid后默认上报，服务端会处理重复的情况
            miniGameOpenid("activate",undefined);
            let openId = this.getOpenId;
            localStorage.setItem("openid", openId);
        }
        // 初始化成了
        this.init = true
        // if (!this.isReport()) return
        let query = { channel: null, trackid: null }
        // 处理抖音和微信小游戏参数
        if (system_info.app == "wx_minigame") {
            firstOpen_wxMini();
            query = wx.getLaunchOptionsSync().query
        } else if (system_info.app == "tt_minigame") {
            query = tt.getLaunchOptionsSync().query
        }
        // 判断广告跳转游戏的来源，哔哩哔哩广告过来的
        if (query?.channel == "bili") {
            console.log("upload_mini小游戏启动参数", query)
            // query.channel = query.channel
            // query.trackid = query.trackid
        } else {
            return
        }
    }
    /**上报角色注册信息 */
    async registerRole(info: any) {
        let param: IUploadUser = info;
        if (param.uploadType === UploadType.ks_ad) {
            registerAd(param)
            return
        }
        else if (param.uploadType === UploadType.baidu) {
            registerBaidu(param)
            return
        }
        else if (param.uploadType === UploadType.txgdt) {
            registerAdGdt(param)
            return
        }
        else if (param.uploadType === UploadType.ios_cdqxz) {
            registerAdiosJL(param);
            return
        } else if (system_info.app == "wx_minigame") {
            register_wxMini();
            return
        } else if (system_info.app = "tt_minigame") {
            sdkUpRegister();
        }
        //小游戏渠道上报到服务器
        miniGameAct("register",undefined);
    }


    async loginRole(info: any) {
        let loginParam: IUploadUser = info;

        if (loginParam.uploadType === UploadType.ks_ad) {
            loginAd(loginParam)
            return;
        } else if (loginParam.uploadType === UploadType.txgdt) {
            loginAdGdt(loginParam)
            return;
        } else if (loginParam.uploadType === UploadType.ios_cdqxz) {
            loginAdiosJL(loginParam);
            return;
        }

        // /**@deprecated 废弃，有需求再启用-上报角色登录信息 */
        // return this.reportRpc("LoginRole", info)
    }

    /** 支付成功 上报 */
    async pay(uploadParam: any, info: any) {
        let payParam: UploadPayParam = info;
        let payUpload: IUploadUser = uploadParam;

        if (payUpload.uploadType === UploadType.ks_ad) {
            payAd(payParam);
            return;
        } else if (payUpload.uploadType === UploadType.txgdt) {
            payBaidu(payParam);
            return;
        } else if (payUpload.uploadType === UploadType.ios_cdqxz) {
            payAdiosJL(payParam);
            return;
        }
        if (system_info.app == "wx_minigame") {
            pay_wxMini(payParam);
        } else if (system_info.app = "tt_minigame") {
            sdkUpActivePay();
        }
        //小游戏渠道上报到服务器
        miniGameAct("paid",payParam.amount);
    }
    /**rpc */
    // async reportRpc(action, info: any) {
    //     try {
    //         if (!this.isReport()) return
    //         let data = new reportMinigame()
    //         data.openId = this.getOpenId
    //         data.action = action
    //         data.info = info
    //         console.log("upload_mini上报参数", action, info)
    //         const result = await clientRpc(adRecord._$topic, data);
    //         return Promise.resolve(result)
    //     } catch (error) {
    //         console.error("reportRpc fail , reason = ", error)
    //     }
    // }
}


export let adgameUpload = new adGameUpload()
