import { PISYS } from "pi_sys/index";
import { adgameUpload } from "./index";
declare var wx;
//广点通小游戏回传需要的字段
let gdt_vid: string = ""; //广告traceid
let weixinadinfo: any = null;
//巨量游戏
//最新文档说参数在ad_params中
let ad_params: string = undefined;
let req_id: string = undefined;
let clue_token: string = undefined;
//taptap小游戏
let tap_track_id: string = undefined;  //用于追踪广告效果的参数
let tap_project_id: string = undefined; //在 tap 的游戏 id
//快手小游戏
let ks_callback: string = undefined; //快手归因参数
//bilibili小游戏
let bili_track_id: string = undefined;  //用于追踪广告效果的参数


//小游戏注册，支付
export const miniGameAct = async (eventType: string, paidAmount: number) => {
    if (!PISYS.PlatformUtil.isMinigame) return;
    //获取微信渠道
    getWxChannel();
    let openId = adgameUpload.getOpenId;
    // let url = PISYS.Env.get("domains")[0];
    let url = "https://cdqxztaptapwss.grokease.xyz/event/handle?event=ad_minigame"

    //如果什么都取不到，说明不是从广告进来的第一次打开，就去服务端读表，是否有广告数据,上报BI的时候用
    if (!clue_token && !gdt_vid && !tap_track_id && !ks_callback && !bili_track_id) {
        let adDetails = await getAdDetails();
        console.log("query_ad ==", adDetails);
        let query = wx.getLaunchOptionsSync().query;
        console.log("query_ad ==", query);
        return;
    }
    let data = {
            openId,
            eventType: eventType,
            paidAmount: (paidAmount !== undefined) ? paidAmount : paidAmount,
        }

    const result = await PISYS.HTTP.get(url, {}, data, '', 10000);
    console.log("ad_upload active == ", result);

}
//这个接口主要用于上传已激活的小游戏的openid,只在第一次激活的时候上传
export const miniGameOpenid = async (eventType: string, paidAmount: number) => {
    if (!PISYS.PlatformUtil.isMinigame) return;
    //获取微信渠道
    getWxChannel();
    let openId = adgameUpload.getOpenId;
    // let url = PISYS.Env.get("domains")[0];
    let url = "https://cdqxztaptapwss.grokease.xyz/event/handle?event=ad_openid"

    //如果什么都取不到，就直接返回
    if (!clue_token && !gdt_vid && !tap_track_id && !ks_callback && !bili_track_id) {
        let query = wx.getLaunchOptionsSync().query;
        console.log("query_ad ==", query);
        return;
    }
    let data;
    //广点通必须要openid,放在pi_upload中登录后上报激活
    // if (gdt_vid) {
    //     data = {
    //         openid,
    //         gdt_vid,
    //         weixinadinfo: weixinadinfo,
    //         channel: "gdtxcx",
    //     }

    // } else 
    //巨量小程序，似乎不需要openid需要测试
    if (clue_token) {
        data = {
            openId,
            clue_token,
            req_id: req_id,
            channel: "jlxcx",
            eventType: eventType,
            paidAmount: (paidAmount !== undefined) ? paidAmount : paidAmount,
        }
    }
    //tap小程序激活不需要openid
    else if (tap_track_id) {
        data = {
            openId,
            tap_track_id,
            tap_project_id: tap_project_id,
            channel: "tapxcx",
            eventType: eventType,
            paidAmount: (paidAmount !== undefined) ? paidAmount : paidAmount,
        }
    }
    //bilibili小程序激活不需要openid
    else if (bili_track_id) {
        data = {
            openId,
            bili_track_id,
            channel: "bilixcx",
            eventType: eventType,
            paidAmount: (paidAmount !== undefined) ? paidAmount : paidAmount,
        }
    }
    //快手小程序激活不需要openid
    else {
        data = {
            openId,
            ks_callback,
            channel: "ksxcx",
            eventType: eventType,
            paidAmount: (paidAmount !== undefined) ? paidAmount : paidAmount,
        }
    }
    const result = await PISYS.HTTP.get(url, {}, data, '', 10000);
    console.log("ad_upload active == ", result);

}
//获取微信携带的参数
export const getWxQuery = async () => {
    //if (!isWXMiniGame()) return;
    let query = wx.getLaunchOptionsSync().query;
    //========巨量==========
    ad_params = query?.ad_params;
    req_id = query?.req_id;
    clue_token = query?.clue_token;
    //========广点通========
    gdt_vid = query?.gdt_vid;
    //广告adinfo，由其他参数拼接而成，值为aid.traceid.scene_type.0，aid为投放端创建广告时生成的广告id
    weixinadinfo = query?.weixinadinfo;
    //========taptap=========
    tap_track_id = query?.tap_track_id;
    tap_project_id = query?.tap_project_id;
    bili_track_id = query?.trackid;
    //=========快手========
    ks_callback = query && query.ksChannel ? query.callback : undefined;
}
//区分微信小游戏广告用户渠道
const getWxChannel = async () => {
    //if (!isWXMiniGame()) return;
    console.log("jl_ad_params===", ad_params)
    //读取前端缓存
    let data;
    // 从 localStorage 中读取数据,并反序列化
    const dataString = localStorage.getItem("wxMiniGameAdInfo");
    if (dataString) {
        data = JSON.parse(dataString);
    }
    if (!dataString) {
        //读取url 
        let query = wx.getLaunchOptionsSync().query;
        if (query) {
            if (query.clue_token) data = { clue_token: query.clue_token };
            if (query.gdt_vid) data = { gdt_vid: query.gdt_vid };
            if (query.tap_track_id) data = { tap_track_id: query.tap_track_id };
            if (query.trackid) data = { bili_track_id: query.trackid };
            if (query.callback) data = { ks_callback: query.callback };
        }
        // 将 data 对象序列化为字符串
        const dataString = JSON.stringify(data);
        localStorage.setItem("wxMiniGameAdInfo", dataString);
    }
    if (!data) return;

    let channel;
    if (data.clue_token) {
        channel = "jlxcx";
    }
    if (data.gdt_vid) {
        channel = "gdtxcx";
    }
    if (data.tap_track_id) {
        channel = "tapxcx";
    }
    if (data.ks_callback) {
        channel = "ksxcx";
    }
    if (data.bili_track_id) {
        channel = "bilixcx";
    }
    localStorage.setItem("channel", channel);
}

//获取服务端表的广告参数
export const getAdDetails = async () => {
    let url = "https://cdqxztaptapwss.grokease.xyz/event/handle?event=adDetails"
    let openId = adgameUpload.getOpenId;
    let data = {
        openId
    }
    const result = await PISYS.HTTP.get(url, {}, data, '', 10000);
    console.log("getAdDetails result == ", result);
    return result;
}