import { Json } from "pi_tools/type";
import { IUploadUser } from "../../interface/upload";
import { UploadPayParam } from "../../interface/pay";
import { IPlatformUpload } from "../interface";

export class MuxueUpload implements IPlatformUpload {
    lastUser: IUploadUser;

    login(param: IUploadUser, isCreateRole?: boolean): Json[] {

        this.lastUser = JSON.parse(JSON.stringify(param));

        let r: IMuxue = {
            type: isCreateRole ? '1' : '2',
            roleId: param.userID,
            roleName: param.userName,
            level: param.roleLevel + '',
            gender: param.userSex,
            serverno: param.serverID,
            zoneName: param.serverName,
            balance: param.roleBalance,
            power: '',
            viplevel: param.roleVipLevel + '',
            roleCtiem: param.createTime + '',
            roleLeveMTimE: param.levelUpTime + '',
            ext: param.extend
        };

        return [
            r as any as Json
        ];
    }

    logout(): Json[] {
        return [];
    }

    pay(_param: UploadPayParam): Json[] {
        return [];
    }

    custom(type: string = '3', param: Json): Json {
        let r: IMuxue = {
            type,
            roleId: this.lastUser.userID,
            roleName: this.lastUser.userName,
            gender: this.lastUser.userSex,
            serverno: this.lastUser.serverID,
            zoneName: this.lastUser.serverName,
            balance: this.lastUser.roleBalance,
            power: '',
            viplevel: this.lastUser.roleVipLevel + '',
            roleCtiem: this.lastUser.createTime + '',
            ext: this.lastUser.extend,

            level: param?.roleLevel + '',
            roleLeveMTimE: param?.levelUpTime + '',
        };

        return [
            r as any as Json
        ];
    }
}

// 暮雪
interface IMuxue {
    type: string,        // 进入服器(2)、玩家创建用户角色(1)、玩家升级(3)
    roleId: string;        //  角色id
    roleName: string;      // 角色名称
    level?: string;    // 角色当前等级
    gender?: string;      // 角色性别
    serverno?: string;    // 服务器id
    zoneName?: string;   // 服务器名称
    balance?: string;   // 游戏币余额
    power?: string;     // 角色战力
    viplevel?: string;  // Vip等级
    roleCtiem?: string;    // 创建角色时间
    roleLeveMTimE?: string;      // 角色等级变化时间
    ext?: string;      // 额外参数
}
