import { Json } from "pi_tools/type";
import { IUploadUser } from "../../interface/upload";
import { UploadPayParam } from "../../interface/pay";
import { IPlatformUpload } from "../interface";

export class MyUpload implements IPlatformUpload {

    
    login(param: IUploadUser, isCreateRole?: boolean): Json[] {
        let r: IMY = {
            eid: isCreateRole ? 31 : 32,
            dsid: param.serverID,
            dsname: param.serverName,
            drid: param.userID,
            drname: param.userName,
            drlevel: param.roleLevel.toString(),
            drbalance: param.roleBalance,
            drvip: param.roleVipLevel.toString(),
            dparty: param.partyName,
            dext: param.extend,
        };

        return [
            r as any as Json
        ];
    }

    logout(): Json[] {
        return [];
    }

    pay(_param: UploadPayParam): Json[] {
        return [];
    }

    custom(_type: string, _value?: Json): Json {
        return null;
    }
}

// 萌友
interface IMY {
    eid: number;        //  [必填] Int - (1)创建角色事件ID=31 (2)进入游戏事件ID=32 (3)角色升级事件ID=35 (4)账号下线事件ID=41
    dsid?: string;      // [选填]服务器ID
    dsname?: string;    // [选填]服务器名称
    drid?: string;      // [选填]角色ID
    drname?: string;    // [选填]角色名称
    drlevel?: string;   // [选填]角色等级
    drbalance?: string; // [选填]角色游戏内余额
    drvip?: string;     // [选填]色游戏内 VIP 等级
    dcountry?: string;  // [选填]门派/国家/职业(例如：武当派、龙宫、吴国、法师)
    dparty?: string;    // [选填]公会
    dext?: string;      // [选填]此参数为 Json 形式，可以自己定义参数(选传)
}
