import { Json } from "pi_tools/type";
import { IUploadUser } from "../../interface/upload";
import { UploadPayParam } from "../../interface/pay";
import { IPlatformUpload } from "../interface";

/**
 * 煜辰 数据上报 接口
 */
export class YcUpload implements IPlatformUpload {

    login(param: IUploadUser, _isCreateRole?: boolean): Json[] {
        let r: IYC = {
            serverID: param.serverID,
            serverName: param.serverName,
            roleID: param.userID,
            roleName: param.userName,
            roleLevel: param.roleLevel.toString(),
            payLevel: param.roleVipLevel.toString(),
            extendstr: param.extend,
        };

        return [
            r as any as Json,
        ]
    }

    logout(): Json[] {
        return [];
    }

    pay(_param: UploadPayParam): Json[] {
        return [];
    }

    custom(_type: string, _value?: Json): Json {
        return null;
    }
}


interface IYC {
    serverID: string,       // 服务器ID
    serverName: string,     // 服务器名称
    roleID: string,         // 角色ID
    roleName: string,       // 角色名称
    roleLevel: string,      // 角色等级
    payLevel: string,       // 充值等级
    extendstr: string,      // 拓展字段
}